Index: /palm/trunk/SOURCE/multi_agent_system_mod.f90
===================================================================
--- /palm/trunk/SOURCE/multi_agent_system_mod.f90	(revision 4752)
+++ /palm/trunk/SOURCE/multi_agent_system_mod.f90	(revision 4753)
@@ -992,1201 +993,990 @@
              IF ( number_of_agents <= 0 )  CYCLE
              agents => grid_agents(jp,ip)%agents(1:number_of_agents)
-
-             DO  n = local_start(jp,ip), number_of_agents  !only new agents 
-
-                agents(n)%id = 10000_idp**2 * grid_agents(jp,ip)%id_counter +  &
-                               10000_idp * jp + ip
-!
-!--             Count the number of agents that have been released before
-                grid_agents(jp,ip)%id_counter = grid_agents(jp,ip)%id_counter  &
-                                                + 1
-
+!
+!--          Move only new agents. Moreover, limit random fluctuation in order to prevent that
+!--          agents move more than one grid box, which would lead to problems concerning agent
+!--          exchange  between processors in case adx/ady are larger than dx/dy, respectively.
+             DO  n = local_start(jp,ip), number_of_agents
+                IF ( asl(agents(n)%group) /= asr(agents(n)%group) )  THEN
+                   rand_contr = ( random_function( iran_agent ) - 0.5_wp ) * adx(agents(n)%group)
+                   agents(n)%x = agents(n)%x + MERGE( rand_contr, SIGN( dx, rand_contr ),          &
+                                                      ABS( rand_contr ) < dx                       &
+                                                    )
+                ENDIF
+                IF ( ass(agents(n)%group) /= asn(agents(n)%group) )  THEN
+                   rand_contr = ( random_function( iran_agent ) - 0.5_wp ) * ady(agents(n)%group)
+                   agents(n)%y = agents(n)%y +                                                     &
+                                 MERGE( rand_contr, SIGN( dy, rand_contr ), ABS( rand_contr ) < dy )
+                ENDIF
              ENDDO
+!
+!--          Delete agents that have been simulated longer than allowed
+             CALL mas_boundary_conds( 'max_sim_time' )
+!
+!--          Delete agents that have reached target area
+             CALL mas_boundary_conds( 'target_area' )
 
           ENDDO
        ENDDO
-
-!
-!--    Add random fluctuation to agent positions.
-       IF ( random_start_position_agents )  THEN
-          DO  ip = nxl, nxr
-             DO  jp = nys, nyn
-                number_of_agents = agt_count(jp,ip)
-                IF ( number_of_agents <= 0 )  CYCLE
-                agents => grid_agents(jp,ip)%agents(1:number_of_agents)
-!
-!--             Move only new agents. Moreover, limit random fluctuation 
-!--             in order to prevent that agents move more than one grid box, 
-!--             which would lead to problems concerning agent exchange 
-!--             between processors in case adx/ady are larger than dx/dy, 
-!--             respectively.  
-                DO  n = local_start(jp,ip), number_of_agents
-                   IF ( asl(agents(n)%group) /= asr(agents(n)%group) )  THEN
-                      rand_contr = ( random_function( iran_agent ) - 0.5_wp ) *&
-                                     adx(agents(n)%group)
-                      agents(n)%x = agents(n)%x +                        &
-                              MERGE( rand_contr, SIGN( dx, rand_contr ),       &
-                                     ABS( rand_contr ) < dx                    &
-                                   ) 
-                   ENDIF
-                   IF ( ass(agents(n)%group) /= asn(agents(n)%group) )  THEN
-                      rand_contr = ( random_function( iran_agent ) - 0.5_wp ) *&
-                                     ady(agents(n)%group)
-                      agents(n)%y = agents(n)%y +                        &
-                              MERGE( rand_contr, SIGN( dy, rand_contr ),       &
-                                     ABS( rand_contr ) < dy )
-                   ENDIF
-                ENDDO
-!
-!--             Delete agents that have been simulated longer than allowed
-                CALL mas_boundary_conds( 'max_sim_time' )
-!
-!--             Delete agents that have reached target area
-                CALL mas_boundary_conds( 'target_area' )
-
-             ENDDO
-          ENDDO
-!
-!--       Exchange agents between grid cells and processors
-          CALL mas_eh_move_agent
-          CALL mas_eh_exchange_horiz
-
-       ENDIF
-!
-!--    In case of random_start_position_agents, delete agents identified by 
-!--    mas_eh_exchange_horiz and mas_boundary_conds. Then sort agents into 
-!--    blocks, which is needed for a fast interpolation of the LES fields 
-!--    on the agent position.
-       CALL mas_ps_sort_in_subboxes
-
-!
-!--    Determine the current number of agents
-       number_of_agents = 0
+!
+!--    Exchange agents between grid cells and processors
+       CALL mas_eh_move_agent
+       CALL mas_eh_exchange_horiz
+
+    ENDIF
+!
+!-- In case of random_start_position_agents, delete agents identified by mas_eh_exchange_horiz and
+!-- mas_boundary_conds. Then sort agents into blocks, which is needed for a fast interpolation of
+!-- the LES fields on the agent position.
+    CALL mas_ps_sort_in_subboxes
+
+!
+!-- Determine the current number of agents
+    number_of_agents = 0
+    DO  ip = nxl, nxr
+       DO  jp = nys, nyn
+          number_of_agents = number_of_agents + agt_count(jp,ip)
+       ENDDO
+    ENDDO
+!
+!-- Calculate the number of agents of the total domain
+#if defined( __parallel )
+    IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
+    CALL MPI_ALLREDUCE( number_of_agents, total_number_of_agents, 1, MPI_INTEGER, MPI_SUM, comm2d, &
+                        ierr )
+#else
+    total_number_of_agents = number_of_agents
+#endif
+
+    RETURN
+
+ END SUBROUTINE mas_create_agent
+
+!--------------------------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Creates flags that indicate if a gridbox contains edges or corners. These flags are used for
+!> agents to check if obstacles are close to them.
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE mas_create_obstacle_flags
+
+    USE arrays_3d,                                                                                 &
+        ONLY:  zw
+
+    IMPLICIT NONE
+
+    INTEGER(iwp) ::  il
+    INTEGER(iwp) ::  jl
+
+    ALLOCATE( obstacle_flags(nysg:nyng,nxlg:nxrg) )
+
+    obstacle_flags = 0
+
+    DO  il = nxlg, nxrg
+       DO  jl = nysg, nyng
+!
+!--       Exclude cyclic topography boundary
+          IF ( il < 0 .OR. il > nx .OR. jl < 0 .OR. jl > ny ) CYCLE
+!
+!--       North edge
+          IF ( jl < nyng )  THEN
+             IF ( ( top_top_s(jl,il) - top_top_s(jl+1,il) ) > 1  .AND.                             &
+                  ( zw( top_top_w(jl,il) ) - zw( top_top_w(jl+1,il) ) ) > 0.51_wp )                &
+             THEN
+                obstacle_flags(jl,il) = IBSET( obstacle_flags(jl,il), 0 )
+             ENDIF
+          ENDIF
+!
+!--       North right corner
+          IF ( jl < nyng  .AND.  il < nxrg )  THEN
+             IF ( ( top_top_s(jl,il) - top_top_s(jl+1,il)   ) > 1  .AND.                           &
+                  ( top_top_s(jl,il) - top_top_s(jl+1,il+1) ) > 1  .AND.                           &
+                  ( top_top_s(jl,il) - top_top_s(jl,il+1)   ) > 1  .AND.                           &
+                  ( zw( top_top_w(jl,il) ) - zw( top_top_w(jl+1,il+1) ) ) > 0.51_wp )              &
+             THEN
+                obstacle_flags(jl,il) = IBSET( obstacle_flags(jl,il), 1 )
+             ENDIF
+          ENDIF
+!
+!--       Right edge
+          IF ( il < nxrg )  THEN
+             IF ( ( top_top_s(jl,il) - top_top_s(jl,il+1) ) > 1  .AND.                             &
+                  ( zw( top_top_w(jl,il) ) - zw( top_top_w(jl,il+1) ) ) > 0.51_wp )                &
+             THEN
+                obstacle_flags(jl,il) = IBSET( obstacle_flags(jl,il), 2 )
+             ENDIF
+          ENDIF
+!
+!--       South right corner
+          IF ( jl > nysg  .AND.  il < nxrg )  THEN
+             IF ( ( top_top_s(jl,il) - top_top_s(jl,il+1)   ) > 1  .AND.                           &
+                  ( top_top_s(jl,il) - top_top_s(jl-1,il+1) ) > 1  .AND.                           &
+                  ( top_top_s(jl,il) - top_top_s(jl-1,il)   ) > 1  .AND.                           &
+                  ( zw(top_top_w(jl,il) ) - zw( top_top_w(jl-1,il+1) ) ) > 0.51_wp )               &
+             THEN
+                obstacle_flags(jl,il) = IBSET( obstacle_flags(jl,il), 3 )
+             ENDIF
+          ENDIF
+!
+!--       South edge
+          IF ( jl > nysg )  THEN
+             IF ( ( top_top_s(jl,il) - top_top_s(jl-1,il) ) > 1  .AND.                             &
+                  ( zw( top_top_w(jl,il) ) - zw( top_top_w(jl-1,il) ) ) > 0.51_wp )                &
+             THEN
+                obstacle_flags(jl,il) = IBSET( obstacle_flags(jl,il), 4 )
+             ENDIF
+          ENDIF
+!
+!--       South left corner
+          IF ( jl > nysg  .AND.  il > nxlg )  THEN
+             IF ( ( top_top_s(jl,il) - top_top_s(jl-1,il)   ) > 1  .AND.                           &
+                  ( top_top_s(jl,il) - top_top_s(jl-1,il-1) ) > 1  .AND.                           &
+                  ( top_top_s(jl,il) - top_top_s(jl,il-1)   ) > 1  .AND.                           &
+                  ( zw( top_top_w(jl,il) ) - zw(top_top_w(jl-1,il-1) ) ) > 0.51_wp )               &
+             THEN
+                obstacle_flags(jl,il) = IBSET( obstacle_flags(jl,il), 5 )
+             ENDIF
+          ENDIF
+!
+!--       Left edge
+          IF ( il > nxlg )  THEN
+             IF ( ( top_top_s(jl,il) - top_top_s(jl,il-1) ) > 1  .AND.                             &
+                  ( zw(top_top_w(jl,il) ) - zw(top_top_w(jl,il-1) ) ) > 0.51_wp )                  &
+             THEN
+                obstacle_flags(jl,il) = IBSET( obstacle_flags(jl,il), 6 )
+             ENDIF
+          ENDIF
+!
+!--       North left corner
+          IF ( jl < nyng  .AND.  il > nxlg )  THEN
+             IF ( ( top_top_s(jl,il) - top_top_s(jl,il-1)   ) > 1  .AND.                           &
+                  ( top_top_s(jl,il) - top_top_s(jl+1,il-1) ) > 1  .AND.                           &
+                  ( top_top_s(jl,il) - top_top_s(jl+1,il)   ) > 1  .AND.                           &
+                  ( zw( top_top_w(jl,il) ) - zw( top_top_w(jl+1,il-1) ) ) > 0.51_wp )              &
+             THEN
+                obstacle_flags(jl,il) = IBSET( obstacle_flags(jl,il), 7 )
+             ENDIF
+          ENDIF
+
+       ENDDO
+    ENDDO
+
+ END SUBROUTINE mas_create_obstacle_flags
+
+!--------------------------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Write agent data in netCDF format
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE mas_data_output_agents( ftest )
+
+    USE control_parameters,                                                                        &
+        ONLY:  agt_time_count, biometeorology, end_time, message_string, multi_agent_system_end,   &
+               multi_agent_system_start
+
+    USE netcdf_interface,                                                                          &
+        ONLY:  nc_stat, id_set_agt, id_var_time_agt, id_var_agt, netcdf_handle_error
+
+    USE pegrid
+
+#if defined( __netcdf )
+    USE NETCDF
+#endif
+    USE mas_global_attributes,                                                                     &
+        ONLY:  dim_size_agtnum
+
+    IMPLICIT NONE
+
+#if defined( __parallel )
+    INTEGER(iwp) ::  agt_size !< Agent size in bytes
+    INTEGER(iwp) ::  n        !< counter (number of PEs)
+    INTEGER(iwp) ::  noa_rcv  !< received number of agents
+#endif
+    INTEGER(iwp) ::  dummy    !< dummy
+    INTEGER(iwp) ::  ii       !< counter (x)
+    INTEGER(iwp) ::  ip       !< counter (x)
+    INTEGER(iwp) ::  jp       !< counter (y)
+    INTEGER(iwp) ::  noa      !< number of agents
+    INTEGER(iwp) ::  out_noa  !< number of agents for output
+
+#if defined( __parallel )
+    INTEGER(iwp), DIMENSION(0:numprocs-1) ::  noa_arr !< number of agents on each PE
+#endif
+!
+!-- SAVE attribute required to avoid compiler warning about pointer outlive the pointer target
+    TYPE(agent_type), DIMENSION(:), ALLOCATABLE, TARGET, SAVE ::  trf_agents !< all agents on current PE
+#if defined( __parallel )
+    TYPE(agent_type), DIMENSION(:), ALLOCATABLE, TARGET, SAVE ::  out_agents !< all agents in entire domain
+#endif
+
+    LOGICAL, INTENT (INOUT) :: ftest
+
+    LOGICAL, SAVE :: agt_dimension_exceeded = .FALSE.
+
+
+    CALL cpu_log( log_point_s(17), 'mas_data_output', 'start' )
+!
+!-- Get total number of agents and put all agents on one PE in one array
+    noa = 0
+    DO  ip = nxl, nxr
+       DO  jp = nys, nyn
+          noa  = noa  + agt_count(jp,ip)
+       ENDDO
+    ENDDO
+    IF ( noa > 0 )  THEN
+       ALLOCATE( trf_agents(1:noa) )
+       dummy = 1
        DO  ip = nxl, nxr
           DO  jp = nys, nyn
-             number_of_agents = number_of_agents + agt_count(jp,ip)
+             IF ( agt_count(jp,ip) == 0 )  CYCLE
+             agents => grid_agents(jp,ip)%agents(1:agt_count(jp,ip))
+             trf_agents(dummy:(dummy-1+agt_count(jp,ip))) = agents
+             dummy = dummy + agt_count(jp,ip)
           ENDDO
        ENDDO
-!
-!--    Calculate the number of agents of the total domain
+    ENDIF
 #if defined( __parallel )
-       IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLREDUCE( number_of_agents, total_number_of_agents, 1, &
-       MPI_INTEGER, MPI_SUM, comm2d, ierr )
+!
+!-- Gather all agents on PE0 for output
+    IF ( myid == 0 )  THEN
+       noa_arr(0) = noa
+!
+!--    Receive data from all other PEs.
+       DO  n = 1, numprocs-1
+           CALL MPI_RECV( noa_arr(n), 1, MPI_INTEGER, n, 0, comm2d, status, ierr )
+       ENDDO
+    ELSE
+       CALL MPI_SEND( noa, 1, MPI_INTEGER, 0, 0, comm2d, ierr )
+    ENDIF
+    CALL MPI_BARRIER( comm2d, ierr )
+    agt_size = STORAGE_SIZE( zero_agent ) / 8
+    IF ( myid == 0 )  THEN
+!
+!--    Receive data from all other PEs.
+       out_noa = SUM( noa_arr )
+       IF ( out_noa > 0 )  THEN
+          ALLOCATE( out_agents(1:out_noa) )
+          IF ( noa > 0 )  THEN
+             out_agents(1:noa) = trf_agents
+          ENDIF
+          noa_rcv = noa
+          DO  n = 1, numprocs-1
+             IF ( noa_arr(n) > 0 )  THEN
+                CALL MPI_RECV( out_agents(noa_rcv+1), noa_arr(n) * agt_size, MPI_BYTE, n, 0,       &
+                               comm2d, status, ierr )
+                noa_rcv = noa_rcv + noa_arr(n)
+             ENDIF
+          ENDDO
+       ELSE
+          ALLOCATE( out_agents(1:2) )
+          out_agents = zero_agent
+          out_noa    = 2
+       ENDIF
+    ELSE
+       IF ( noa > 0 )  THEN
+          CALL MPI_SEND( trf_agents(1), noa*agt_size, MPI_BYTE, 0, 0, comm2d, ierr )
+       ENDIF
+    ENDIF
+!
+!-- A barrier has to be set, because otherwise some PEs may proceed too fast so that PE0 may receive
+!-- wrong data on tag 0.
+    CALL MPI_BARRIER( comm2d, ierr )
+#endif
+    IF ( myid == 0 )  THEN
+#if defined( __parallel )
+       agents => out_agents
 #else
-       total_number_of_agents = number_of_agents
+       agents => trf_agents
 #endif
 
-       RETURN
-
-    END SUBROUTINE mas_create_agent
-
-!------------------------------------------------------------------------------!
+#if defined( __netcdf )
+!
+!--    Update maximum number of agents
+       maximum_number_of_agents = MAX(maximum_number_of_agents, out_noa)
+!
+!--       Output in netCDF format
+       IF ( ftest )  THEN
+!
+!--          First, define size of agent number dimension from amount of agents released, release
+!--          interval, time of agent simulation and max age of agents.
+          dim_size_agtnum = MIN( MIN( multi_agent_system_end, end_time )                           &
+                                    - multi_agent_system_start,                                    &
+                                 agent_maximum_age)
+
+          DO ii = 1, number_of_agent_groups
+             dim_size_agtnum = dim_size_agtnum                                                     &
+                                + ( FLOOR( ( asr(ii)-asl(ii) ) / adx(ii) ) + 1 )                   &
+                                * ( FLOOR( ( asn(ii)-ass(ii) ) / ady(ii) ) + 1 )                   &
+                                * ( FLOOR( dim_size_agtnum / dt_arel )     + 1 )                   &
+                                * dim_size_factor_agtnum
+             dim_size_agtnum = MIN( dim_size_agtnum, dim_size_agtnum_manual )
+          ENDDO
+          CALL check_open( 118 )
+       ENDIF
+
+!
+!--    Update the NetCDF time axis
+       agt_time_count = agt_time_count + 1
+
+       IF ( .NOT. agt_dimension_exceeded )  THEN
+!
+!--       If number of agents to be output exceeds dimension, set flag and print warning.
+          IF ( out_noa > dim_size_agtnum )  THEN
+
+             agt_dimension_exceeded = .TRUE.
+             WRITE( message_string, '(A,F11.1,2(A,I8))' )                                          &
+                                                  'Number of agents exceeds agent dimension.' //   &
+                                                  '&Starting at time_since_reference_point = ',    &
+                                                  time_since_reference_point,                      &
+                                                  ' s, &data may be missing.'//                    &
+                                                  '&Number of agents:     ', out_noa,              &
+                                                  '&Agent dimension size: ', dim_size_agtnum
+
+             CALL message( 'mas_data_output_agents', 'PA0420', 0, 1, 0, 6, 0 )
+
+          ENDIF
+       ENDIF
+
+!
+!--    Reduce number of output agents to dimension size, if necessary.
+       IF ( agt_dimension_exceeded )  THEN
+
+          out_noa = MIN( out_noa, dim_size_agtnum )
+
+       ENDIF
+
+       nc_stat = NF90_PUT_VAR( id_set_agt, id_var_time_agt,                                        &
+                               (/ time_since_reference_point + agent_substep_time /),              &
+                               start = (/ agt_time_count /),                                       &
+                               count = (/ 1 /) )
+       CALL netcdf_handle_error( 'mas_data_output_agents', 1 )
+
+!
+!--       Output agent attributes
+
+       nc_stat = NF90_PUT_VAR( id_set_agt, id_var_agt(1), agents%id,                               &
+                               start = (/ 1, agt_time_count /),                                    &
+                               count = (/ out_noa /) )
+       CALL netcdf_handle_error( 'mas_data_output_agents', 2 )
+
+       nc_stat = NF90_PUT_VAR( id_set_agt, id_var_agt(2), agents%x,                                &
+                               start = (/ 1, agt_time_count /),                                    &
+                               count = (/ out_noa /) )
+       CALL netcdf_handle_error( 'mas_data_output_agents', 3 )
+
+       nc_stat = NF90_PUT_VAR( id_set_agt, id_var_agt(3), agents%y,                                &
+                               start = (/ 1, agt_time_count /),                                    &
+                               count = (/ out_noa /) )
+       CALL netcdf_handle_error( 'mas_data_output_agents', 4 )
+
+       nc_stat = NF90_PUT_VAR( id_set_agt, id_var_agt(4), agents%windspeed,                        &
+                               start = (/ 1, agt_time_count /),                                    &
+                               count = (/ out_noa /) )
+       CALL netcdf_handle_error( 'mas_data_output_agents', 5 )
+
+       nc_stat = NF90_PUT_VAR( id_set_agt, id_var_agt(5), agents%t,                                &
+                               start = (/ 1, agt_time_count /),                                    &
+                               count = (/ out_noa /) )
+       CALL netcdf_handle_error( 'mas_data_output_agents', 6 )
+
+       nc_stat = NF90_PUT_VAR( id_set_agt, id_var_agt(6), agents%group,                            &
+                               start = (/ 1, agt_time_count /),                                    &
+                               count = (/ out_noa /) )
+       CALL netcdf_handle_error( 'mas_data_output_agents', 7 )
+
+
+       IF ( biometeorology )  THEN
+          nc_stat = NF90_PUT_VAR( id_set_agt, id_var_agt(7), agents%ipt,                           &
+                                  start = (/ 1, agt_time_count /),                                 &
+                                  count = (/ out_noa /) )
+          CALL netcdf_handle_error( 'mas_data_output_agents', 8 )
+       ENDIF
+
+
+
+!           nc_stat = NF90_PUT_VAR( id_set_agt, id_var_agt(8), agents%pm10,                         &
+!                                   start = (/ 1, agt_time_count /),                                &
+!                                   count = (/ out_noa /) )
+!           CALL netcdf_handle_error( 'mas_data_output_agents', 9 )
+!
+!           nc_stat = NF90_PUT_VAR( id_set_agt, id_var_agt(9), agents%pm25,                         &
+!                                   start = (/ 1, agt_time_count /),                                &
+!                                   count = (/ out_noa /) )
+!           CALL netcdf_handle_error( 'mas_data_output_agents', 10 )
+!
+!
+!           nc_stat = NF90_PUT_VAR( id_set_agt, id_var_agt(9), agents%uv,                           &
+!                                   start = (/ 1, agt_time_count /),                                &
+!                                   count = (/ out_noa /) )
+!           CALL netcdf_handle_error( 'mas_data_output_agents', 10 )
+
+       CALL cpu_log( log_point_s(17), 'mas_data_output', 'stop' )
+
+
+#endif
+
+#if defined( __parallel )
+       IF ( ALLOCATED( out_agents ) ) DEALLOCATE( out_agents )
+#endif
+    ELSE
+       CALL cpu_log( log_point_s(17), 'mas_data_output', 'stop' )
+    ENDIF
+
+    IF ( ALLOCATED( trf_agents ) ) DEALLOCATE( trf_agents )
+
+ END SUBROUTINE mas_data_output_agents
+
+#if defined( __parallel )
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Creates flags that indicate if a gridbox contains edges or corners. These
-!> flags are used for agents to check if obstacles are close to them.
-!------------------------------------------------------------------------------!
-    SUBROUTINE mas_create_obstacle_flags
-
-       USE arrays_3d,                                                          &
-           ONLY:  zw
-
-       IMPLICIT NONE
-
-       INTEGER(iwp) ::  il
-       INTEGER(iwp) ::  jl
-
-       ALLOCATE(obstacle_flags(nysg:nyng,nxlg:nxrg))
-
-       obstacle_flags = 0
-
-       DO il = nxlg, nxrg
-          DO jl = nysg, nyng
-!
-!--          Exclude cyclic topography boundary
-             IF ( il < 0 .OR. il > nx .OR. jl < 0 .OR. jl > ny ) CYCLE
-!
-!--          North edge
-             IF ( jl < nyng ) THEN
-                IF ( ( top_top_s(jl,il) - top_top_s(jl+1,il) ) > 1 .AND.       &
-                     ( zw( top_top_w(jl,il) ) -                                &
-                       zw( top_top_w(jl+1,il) ) ) > .51_wp )                   &
-                THEN
-                   obstacle_flags(jl,il) = IBSET( obstacle_flags(jl,il), 0 )
+!> If an agent moves from one processor to another, this subroutine moves the corresponding elements
+!> from the agent arrays of the old grid cells to the agent arrays of the new grid cells.
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE mas_eh_add_agents_to_gridcell (agent_array)
+
+    IMPLICIT NONE
+
+    INTEGER(iwp) ::  aindex  !< dummy argument for new number of agents per grid box
+    INTEGER(iwp) ::  ip      !< grid index (x) of agent
+    INTEGER(iwp) ::  jp      !< grid index (x) of agent
+    INTEGER(iwp) ::  n       !< index variable of agent
+
+    LOGICAL ::  pack_done  !< flag to indicate that packing is done
+
+    TYPE(agent_type), DIMENSION(:), INTENT(IN)  ::  agent_array  !< new agents in a grid box
+    TYPE(agent_type), DIMENSION(:), ALLOCATABLE ::  temp_ns      !< temporary agent array for reallocation
+
+    pack_done     = .FALSE.
+
+    DO  n = 1, SIZE(agent_array)
+
+       IF ( .NOT. agent_array(n)%agent_mask )  CYCLE
+
+       ip = agent_array(n)%x * ddx
+       jp = agent_array(n)%y * ddy
+
+       IF ( ip >= nxl  .AND.  ip <= nxr  .AND.  jp >= nys  .AND.  jp <= nyn )  THEN ! agent stays on processor
+          number_of_agents = agt_count(jp,ip)
+          agents => grid_agents(jp,ip)%agents(1:number_of_agents)
+
+          aindex = agt_count(jp,ip)+1
+          IF( aindex > SIZE( grid_agents(jp,ip)%agents ) )  THEN
+             IF ( pack_done )  THEN
+                CALL mas_eh_realloc_agents_array (ip,jp)
+             ELSE
+                CALL mas_ps_pack
+                agt_count(jp,ip) = number_of_agents
+                aindex = agt_count(jp,ip)+1
+                IF ( aindex > SIZE( grid_agents(jp,ip)%agents ) )  THEN
+                   CALL mas_eh_realloc_agents_array (ip,jp)
+                ENDIF
+                pack_done = .TRUE.
+             ENDIF
+          ENDIF
+          grid_agents(jp,ip)%agents(aindex) = agent_array(n)
+          agt_count(jp,ip) = aindex
+       ELSE
+          IF ( jp <= nys - 1 )  THEN
+             nr_move_south = nr_move_south+1
+!
+!--          Before agent information is swapped to exchange-array, check if enough memory is
+!--          allocated. If required, reallocate exchange array.
+             IF ( nr_move_south > SIZE( move_also_south ) )  THEN
+!
+!--             At first, allocate further temporary array to swap agent information.
+                ALLOCATE( temp_ns( SIZE( move_also_south ) + nr_2_direction_move ) )
+                temp_ns(1:nr_move_south-1) = move_also_south(1:nr_move_south-1)
+                DEALLOCATE( move_also_south )
+                ALLOCATE( move_also_south( SIZE(temp_ns) ) )
+                move_also_south(1:nr_move_south-1) = temp_ns(1:nr_move_south-1)
+                DEALLOCATE( temp_ns )
+
+             ENDIF
+
+             move_also_south(nr_move_south) = agent_array(n)
+
+             IF ( jp == -1 )  THEN
+!
+!--             Apply boundary condition along y
+                IF ( ibc_mas_ns == 0 )  THEN
+                   move_also_south(nr_move_south)%y = move_also_south(nr_move_south)%y             &
+                                                      + ( ny + 1 ) * dy
+                   move_also_south(nr_move_south)%origin_y =                                       &
+                                                         move_also_south(nr_move_south)%origin_y   &
+                                                         + ( ny + 1 ) * dy
+                ELSEIF ( ibc_mas_ns == 1 )  THEN
+!
+!--                Agent absorption
+                   move_also_south(nr_move_south)%agent_mask = .FALSE.
+                   deleted_agents = deleted_agents + 1
+
                 ENDIF
              ENDIF
-!
-!--          North right corner
-             IF ( jl < nyng .AND. il < nxrg ) THEN
-                IF ( ( top_top_s(jl,il) - top_top_s(jl+1,il) )   > 1 .AND.     &
-                     ( top_top_s(jl,il) - top_top_s(jl+1,il+1) ) > 1 .AND.     &
-                     ( top_top_s(jl,il) - top_top_s(jl,il+1) )   > 1 .AND.     &
-                     ( zw( top_top_w(jl,il) ) -                                &
-                       zw( top_top_w(jl+1,il+1) ) ) > .51_wp )                 &
-                THEN
-                   obstacle_flags(jl,il) = IBSET( obstacle_flags(jl,il), 1 )
-                ENDIF
+          ELSEIF ( jp >= nyn+1 )  THEN
+             nr_move_north = nr_move_north+1
+!
+!--          Before agent information is swapped to exchange-array, check  if enough memory is
+!--          allocated. If required, reallocate exchange array.
+             IF ( nr_move_north > SIZE( move_also_north ) )  THEN
+!
+!--             At first, allocate further temporary array to swap agent information.
+                ALLOCATE( temp_ns( SIZE( move_also_north ) + nr_2_direction_move ) )
+                temp_ns(1:nr_move_north-1) = move_also_south(1:nr_move_north-1)
+                DEALLOCATE( move_also_north )
+                ALLOCATE( move_also_north(SIZE(temp_ns)) )
+                move_also_north(1:nr_move_north-1) = temp_ns(1:nr_move_north-1)
+                DEALLOCATE( temp_ns )
+
              ENDIF
-!
-!--          Right edge
-             IF ( il < nxrg ) THEN
-                IF ( ( top_top_s(jl,il) - top_top_s(jl,il+1) ) > 1 .AND.       &
-                     ( zw( top_top_w(jl,il) ) -                                &
-                       zw( top_top_w(jl,il+1) ) ) > .51_wp )                   &
-                THEN
-                   obstacle_flags(jl,il) = IBSET( obstacle_flags(jl,il), 2 )
-                ENDIF
-             ENDIF
-!
-!--          South right corner
-             IF ( jl > nysg .AND. il < nxrg ) THEN
-                IF ( ( top_top_s(jl,il) - top_top_s(jl,il+1) )   > 1 .AND.     &
-                     ( top_top_s(jl,il) - top_top_s(jl-1,il+1) ) > 1 .AND.     &
-                     ( top_top_s(jl,il) - top_top_s(jl-1,il) )   > 1 .AND.     &
-                     ( zw(top_top_w(jl,il)) -                                  &
-                       zw( top_top_w(jl-1,il+1) ) ) > .51_wp )                 &
-                THEN
-                   obstacle_flags(jl,il) = IBSET( obstacle_flags(jl,il), 3 )
-                ENDIF
-             ENDIF
-!
-!--          South edge
-             IF ( jl > nysg ) THEN
-                IF ( ( top_top_s(jl,il) - top_top_s(jl-1,il) ) > 1 .AND.       &
-                     ( zw( top_top_w(jl,il) ) -                                &
-                       zw( top_top_w(jl-1,il) ) ) > .51_wp )                   &
-                THEN
-                   obstacle_flags(jl,il) = IBSET( obstacle_flags(jl,il), 4 )
-                ENDIF
-             ENDIF
-!
-!--          South left corner
-             IF ( jl > nysg .AND. il > nxlg ) THEN
-                IF ( ( top_top_s(jl,il) - top_top_s(jl-1,il) )   > 1 .AND.     &
-                     ( top_top_s(jl,il) - top_top_s(jl-1,il-1) ) > 1 .AND.     &
-                     ( top_top_s(jl,il) - top_top_s(jl,il-1) )   > 1 .AND.     &
-                     ( zw( top_top_w(jl,il) ) -                                &
-                       zw(top_top_w(jl-1,il-1) ) ) > .51_wp )                  &
-                THEN
-                   obstacle_flags(jl,il) = IBSET( obstacle_flags(jl,il), 5 )
-                ENDIF
-             ENDIF
-!
-!--          Left edge
-             IF ( il > nxlg ) THEN
-                IF ( ( top_top_s(jl,il) - top_top_s(jl,il-1) ) > 1 .AND.       &
-                     ( zw(top_top_w(jl,il) ) -                                 &
-                       zw(top_top_w(jl,il-1) ) ) > .51_wp )                 &
-                THEN
-                   obstacle_flags(jl,il) = IBSET( obstacle_flags(jl,il), 6 )
-                ENDIF
-             ENDIF
-!
-!--          North left corner
-             IF ( jl < nyng .AND. il > nxlg ) THEN
-                IF ( ( top_top_s(jl,il) - top_top_s(jl,il-1) )   > 1 .AND.     &
-                     ( top_top_s(jl,il) - top_top_s(jl+1,il-1) ) > 1 .AND.     &
-                     ( top_top_s(jl,il) - top_top_s(jl+1,il) )   > 1 .AND.     &
-                     ( zw( top_top_w(jl,il) ) -                                &
-                       zw( top_top_w(jl+1,il-1) ) ) > .51_wp )                 &
-                THEN
-                   obstacle_flags(jl,il) = IBSET( obstacle_flags(jl,il), 7 )
-                ENDIF
-             ENDIF
-
-          ENDDO
-       ENDDO
-
-    END SUBROUTINE mas_create_obstacle_flags
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Write agent data in netCDF format 
-!------------------------------------------------------------------------------!
-    SUBROUTINE mas_data_output_agents( ftest )
-
-       USE control_parameters,                                                 &
-           ONLY:  agt_time_count, biometeorology, end_time, message_string,    &
-                  multi_agent_system_end, multi_agent_system_start
-
-       USE netcdf_interface,                                                   &
-           ONLY:  nc_stat, id_set_agt, id_var_time_agt,        &
-                  id_var_agt, netcdf_handle_error
-
-       USE pegrid
-
-#if defined( __netcdf )
-       USE NETCDF
-#endif
-       USE mas_global_attributes,                                              &
-           ONLY:  dim_size_agtnum
-
-       IMPLICIT NONE
-
-#if defined( __parallel )
-       INTEGER(iwp) ::  agt_size !< Agent size in bytes
-       INTEGER(iwp) ::  n        !< counter (number of PEs)
-       INTEGER(iwp) ::  noa_rcv  !< received number of agents
-#endif
-       INTEGER(iwp) ::  dummy    !< dummy
-       INTEGER(iwp) ::  ii       !< counter (x)
-       INTEGER(iwp) ::  ip       !< counter (x)
-       INTEGER(iwp) ::  jp       !< counter (y)
-       INTEGER(iwp) ::  noa      !< number of agents
-       INTEGER(iwp) ::  out_noa  !< number of agents for output
-
-#if defined( __parallel )
-       INTEGER(iwp), DIMENSION(0:numprocs-1) ::  noa_arr !< number of agents on each PE
-#endif
-!
-!--    SAVE attribute required to avoid compiler warning about pointer outlive the pointer target
-       TYPE(agent_type), DIMENSION(:), ALLOCATABLE, TARGET, SAVE ::  trf_agents !< all agents on current PE
-#if defined( __parallel )
-       TYPE(agent_type), DIMENSION(:), ALLOCATABLE, TARGET, SAVE ::  out_agents !< all agents in entire domain
-#endif
-
-       LOGICAL, INTENT (INOUT) :: ftest
-
-       LOGICAL, SAVE :: agt_dimension_exceeded = .FALSE.
-
-       CALL cpu_log( log_point_s(17), 'mas_data_output', 'start' )
-!
-!--    Get total number of agents and put all agents on one PE in one array
-       noa = 0
-       DO  ip = nxl, nxr
-          DO  jp = nys, nyn
-             noa  = noa  + agt_count(jp,ip)
-          ENDDO
-       ENDDO
-       IF(noa > 0) THEN
-          ALLOCATE(trf_agents(1:noa))
-          dummy = 1
-          DO  ip = nxl, nxr
-             DO  jp = nys, nyn
-                IF ( agt_count(jp,ip) == 0 ) CYCLE
-                agents => grid_agents(jp,ip)%agents(1:agt_count(jp,ip))
-                trf_agents(dummy:(dummy-1+agt_count(jp,ip))) = agents
-                dummy = dummy + agt_count(jp,ip)
-             ENDDO
-          ENDDO
-       ENDIF
-#if defined( __parallel )
-!
-!--    Gather all agents on PE0 for output
-       IF ( myid == 0 )  THEN
-          noa_arr(0) = noa
-!
-!--       Receive data from all other PEs.
-          DO  n = 1, numprocs-1
-              CALL MPI_RECV( noa_arr(n), 1, MPI_INTEGER,                       &
-                              n, 0, comm2d, status, ierr )
-          ENDDO
-       ELSE
-          CALL MPI_SEND( noa, 1, MPI_INTEGER, 0, 0, comm2d, ierr )
-       ENDIF
-       CALL MPI_BARRIER( comm2d, ierr )
-       agt_size = STORAGE_SIZE(zero_agent)/8
-       IF ( myid == 0 )  THEN
-!
-!--       Receive data from all other PEs.
-          out_noa = SUM(noa_arr)
-          IF ( out_noa > 0 ) THEN
-             ALLOCATE( out_agents(1:out_noa) )
-             IF ( noa > 0 ) THEN
-                out_agents(1:noa) = trf_agents
-             ENDIF
-             noa_rcv = noa
-             DO n = 1, numprocs-1
-                IF ( noa_arr(n) > 0 ) THEN
-                   CALL MPI_RECV( out_agents(noa_rcv+1), noa_arr(n)*agt_size,  &
-                                  MPI_BYTE, n, 0, comm2d, status, ierr )
-                   noa_rcv = noa_rcv + noa_arr(n)
-                ENDIF
-             ENDDO
-          ELSE
-             ALLOCATE( out_agents(1:2) )
-             out_agents = zero_agent
-             out_noa    = 2
-          ENDIF
-       ELSE
-          IF ( noa > 0 ) THEN
-             CALL MPI_SEND( trf_agents(1), noa*agt_size, MPI_BYTE, 0, 0,       &
-                                        comm2d, ierr )
-          ENDIF
-       ENDIF
-!
-!--    A barrier has to be set, because otherwise some PEs may
-!--    proceed too fast so that PE0 may receive wrong data on
-!--    tag 0
-       CALL MPI_BARRIER( comm2d, ierr )
-#endif
-       IF ( myid == 0 ) THEN
-#if defined( __parallel )
-          agents => out_agents
-#else
-          agents => trf_agents
-#endif
-
-#if defined( __netcdf )
-!
-!--       Update maximum number of agents
-          maximum_number_of_agents = MAX(maximum_number_of_agents, out_noa)
-!
-!--       Output in netCDF format
-          IF ( ftest ) THEN
-!
-!--          First, define size of agent number dimension from amount of agents
-!--          released, release interval, time of agent simulation and max
-!--          age of agents
-             dim_size_agtnum = MIN( MIN( multi_agent_system_end, end_time )    &
-                                       - multi_agent_system_start,             &
-                                    agent_maximum_age)
-
-             DO ii = 1, number_of_agent_groups
-                dim_size_agtnum = dim_size_agtnum                              &
-                                + (FLOOR( ( asr(ii)-asl(ii) ) / adx(ii) ) + 1) &
-                                * (FLOOR( ( asn(ii)-ass(ii) ) / ady(ii) ) + 1) &
-                                * (FLOOR( dim_size_agtnum / dt_arel )     + 1) &
-                                * dim_size_factor_agtnum
-                dim_size_agtnum = MIN( dim_size_agtnum, dim_size_agtnum_manual )
-             ENDDO
-             CALL check_open( 118 )
-          ENDIF
-
-!
-!--       Update the NetCDF time axis
-          agt_time_count = agt_time_count + 1
-
-          IF ( .NOT. agt_dimension_exceeded ) THEN
-!
-!--          if number of agents to be output exceeds dimension, set flag and
-!--          print warning
-             IF ( out_noa > dim_size_agtnum ) THEN
-
-                agt_dimension_exceeded = .TRUE.
-                WRITE(message_string,'(A,F11.1,2(A,I8))')                      &
-                                'Number of agents exceeds agent dimension.' // &
-                                '&Starting at time_since_reference_point = ',  &
-                                time_since_reference_point,                    &
-                                ' s, &data may be missing.'//                  &
-                                '&Number of agents:     ', out_noa,            &
-                                '&Agent dimension size: ', dim_size_agtnum
-
-                CALL message( 'mas_data_output_agents',                        &
-                              'PA0420', 0, 1, 0, 6, 0 )
-
-             ENDIF
-          ENDIF
-
-!
-!--       reduce number of output agents to dimension size, if necessary
-          IF ( agt_dimension_exceeded ) THEN
-
-             out_noa = MIN( out_noa, dim_size_agtnum )
-
-          ENDIF
-
-          nc_stat = NF90_PUT_VAR( id_set_agt, id_var_time_agt,                 &
-                                  (/ time_since_reference_point + agent_substep_time /),            &
-                                  start = (/ agt_time_count /),                &
-                                  count = (/ 1 /) )
-          CALL netcdf_handle_error( 'mas_data_output_agents', 1 )
-
-!
-!--       Output agent attributes
-
-          nc_stat = NF90_PUT_VAR( id_set_agt, id_var_agt(1), agents%id,        &
-                                  start = (/ 1, agt_time_count /),             &
-                                  count = (/ out_noa /) )
-          CALL netcdf_handle_error( 'mas_data_output_agents', 2 )
- 
-          nc_stat = NF90_PUT_VAR( id_set_agt, id_var_agt(2), agents%x,         &
-                                  start = (/ 1, agt_time_count /),             &
-                                  count = (/ out_noa /) )
-          CALL netcdf_handle_error( 'mas_data_output_agents', 3 )
-
-          nc_stat = NF90_PUT_VAR( id_set_agt, id_var_agt(3), agents%y,         &
-                                  start = (/ 1, agt_time_count /),             &
-                                  count = (/ out_noa /) )
-          CALL netcdf_handle_error( 'mas_data_output_agents', 4 )
-
-          nc_stat = NF90_PUT_VAR( id_set_agt, id_var_agt(4), agents%windspeed, &
-                                  start = (/ 1, agt_time_count /),             &
-                                  count = (/ out_noa /) )
-          CALL netcdf_handle_error( 'mas_data_output_agents', 5 )
-
-          nc_stat = NF90_PUT_VAR( id_set_agt, id_var_agt(5), agents%t,         &
-                                  start = (/ 1, agt_time_count /),             &
-                                  count = (/ out_noa /) )
-          CALL netcdf_handle_error( 'mas_data_output_agents', 6 )
-
-          nc_stat = NF90_PUT_VAR( id_set_agt, id_var_agt(6), agents%group,     &
-                                  start = (/ 1, agt_time_count /),             &
-                                  count = (/ out_noa /) )
-          CALL netcdf_handle_error( 'mas_data_output_agents', 7 )
-
-
-          IF ( biometeorology )  THEN
-             nc_stat = NF90_PUT_VAR( id_set_agt, id_var_agt(7), agents%ipt,    &
-                                     start = (/ 1, agt_time_count /),          &
-                                     count = (/ out_noa /) )
-             CALL netcdf_handle_error( 'mas_data_output_agents', 8 )  
-          ENDIF
-          
-
-          
-!           nc_stat = NF90_PUT_VAR( id_set_agt, id_var_agt(8), agents%pm10,      &
-!                                   start = (/ 1, agt_time_count /),             &
-!                                   count = (/ out_noa /) )
-!           CALL netcdf_handle_error( 'mas_data_output_agents', 9 )
-! 
-!           nc_stat = NF90_PUT_VAR( id_set_agt, id_var_agt(9), agents%pm25,      &
-!                                   start = (/ 1, agt_time_count /),             &
-!                                   count = (/ out_noa /) )
-!           CALL netcdf_handle_error( 'mas_data_output_agents', 10 )
-! 
-! 
-!           nc_stat = NF90_PUT_VAR( id_set_agt, id_var_agt(9), agents%uv,        &
-!                                   start = (/ 1, agt_time_count /),             &
-!                                   count = (/ out_noa /) )
-!           CALL netcdf_handle_error( 'mas_data_output_agents', 10 )
-
-          CALL cpu_log( log_point_s(17), 'mas_data_output', 'stop' )
-
-
-#endif
-
-#if defined( __parallel )
-          IF ( ALLOCATED( out_agents ) ) DEALLOCATE( out_agents )
-#endif
-       ELSE
-          CALL cpu_log( log_point_s(17), 'mas_data_output', 'stop' )
-       ENDIF
-
-       IF ( ALLOCATED( trf_agents ) ) DEALLOCATE( trf_agents )
-
-    END SUBROUTINE mas_data_output_agents
-
-#if defined( __parallel )
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> If an agent moves from one processor to another, this subroutine moves 
-!> the corresponding elements from the agent arrays of the old grid cells 
-!> to the agent arrays of the new grid cells.
-!------------------------------------------------------------------------------!
-    SUBROUTINE mas_eh_add_agents_to_gridcell (agent_array)
-
-       IMPLICIT NONE
-
-       INTEGER(iwp) ::  aindex !< dummy argument for new number of agents per grid box
-       INTEGER(iwp) ::  ip     !< grid index (x) of agent
-       INTEGER(iwp) ::  jp     !< grid index (x) of agent
-       INTEGER(iwp) ::  n      !< index variable of agent
-
-       LOGICAL ::  pack_done !< flag to indicate that packing is done
-
-       TYPE(agent_type), DIMENSION(:), INTENT(IN)  ::  agent_array !< new agents in a grid box
-       TYPE(agent_type), DIMENSION(:), ALLOCATABLE ::  temp_ns     !< temporary agent array for reallocation
-
-       pack_done     = .FALSE.
-
-       DO n = 1, SIZE(agent_array)
-
-          IF ( .NOT. agent_array(n)%agent_mask )  CYCLE
-
-          ip = agent_array(n)%x * ddx
-          jp = agent_array(n)%y * ddy
-
-          IF ( ip >= nxl  .AND.  ip <= nxr  .AND.                              &
-               jp >= nys  .AND.  jp <= nyn )  &
-          THEN ! agent stays on processor
-             number_of_agents = agt_count(jp,ip)
-             agents => grid_agents(jp,ip)%agents(1:number_of_agents)
-
-             aindex = agt_count(jp,ip)+1
-             IF( aindex > SIZE(grid_agents(jp,ip)%agents) )  THEN
-                IF ( pack_done )  THEN
-                   CALL mas_eh_realloc_agents_array (ip,jp)
-                ELSE
-                   CALL mas_ps_pack
-                   agt_count(jp,ip) = number_of_agents
-                   aindex = agt_count(jp,ip)+1
-                   IF ( aindex > SIZE(grid_agents(jp,ip)%agents) )  THEN
-                      CALL mas_eh_realloc_agents_array (ip,jp)
-                   ENDIF
-                   pack_done = .TRUE.
-                ENDIF
-             ENDIF
-             grid_agents(jp,ip)%agents(aindex) = agent_array(n)
-             agt_count(jp,ip) = aindex
-          ELSE
-             IF ( jp <= nys - 1 )  THEN
-                nr_move_south = nr_move_south+1
-!
-!--             Before agent information is swapped to exchange-array, check 
-!--             if enough memory is allocated. If required, reallocate exchange
-!--             array.
-                IF ( nr_move_south > SIZE(move_also_south) )  THEN
-!
-!--                At first, allocate further temporary array to swap agent 
-!--                information.
-                   ALLOCATE( temp_ns(SIZE(move_also_south)+NR_2_direction_move))
-                   temp_ns(1:nr_move_south-1) = move_also_south                &
-                                                (1:nr_move_south-1)
-                   DEALLOCATE( move_also_south )
-                   ALLOCATE( move_also_south(SIZE(temp_ns)) )
-                   move_also_south(1:nr_move_south-1) = temp_ns                &
-                                                        (1:nr_move_south-1)
-                   DEALLOCATE( temp_ns )
-
-                ENDIF
-
-                move_also_south(nr_move_south) = agent_array(n)
-
-                IF ( jp == -1 )  THEN
-!
-!--                Apply boundary condition along y
-                   IF ( ibc_mas_ns == 0 )  THEN
-                      move_also_south(nr_move_south)%y =                       &
-                                         move_also_south(nr_move_south)%y      &
-                                       + ( ny + 1 ) * dy
-                      move_also_south(nr_move_south)%origin_y =                &
-                                       move_also_south(nr_move_south)%origin_y &
-                                       + ( ny + 1 ) * dy
-                   ELSEIF ( ibc_mas_ns == 1 )  THEN
-!
-!--                   Agent absorption
-                      move_also_south(nr_move_south)%agent_mask = .FALSE.
-                      deleted_agents = deleted_agents + 1
-
-                   ENDIF
-                ENDIF
-             ELSEIF ( jp >= nyn+1 )  THEN
-                nr_move_north = nr_move_north+1
-!
-!--             Before agent information is swapped to exchange-array, check 
-!--             if enough memory is allocated. If required, reallocate exchange
-!--             array.
-                IF ( nr_move_north > SIZE(move_also_north) )  THEN
-!
-!--                At first, allocate further temporary array to swap agent 
-!--                information.
-                   ALLOCATE( temp_ns(SIZE(move_also_north)+NR_2_direction_move))
-                   temp_ns(1:nr_move_north-1) =                                &
-                                move_also_south(1:nr_move_north-1)
-                   DEALLOCATE( move_also_north )
-                   ALLOCATE( move_also_north(SIZE(temp_ns)) )
-                   move_also_north(1:nr_move_north-1) =                        &
-                               temp_ns(1:nr_move_north-1)
-                   DEALLOCATE( temp_ns )
-
-                ENDIF
-
-                move_also_north(nr_move_north) = agent_array(n)
-                IF ( jp == ny+1 )  THEN
-!
-!--                Apply boundary condition along y
-                   IF ( ibc_mas_ns == 0 )  THEN
-
-                      move_also_north(nr_move_north)%y =                       &
-                         move_also_north(nr_move_north)%y                      &
-                       - ( ny + 1 ) * dy
-                      move_also_north(nr_move_north)%origin_y =                &
-                         move_also_north(nr_move_north)%origin_y               &
-                       - ( ny + 1 ) * dy
-                   ELSEIF ( ibc_mas_ns == 1 )  THEN
-!
-!--                   Agent absorption
-                      move_also_north(nr_move_north)%agent_mask = .FALSE.
-                      deleted_agents = deleted_agents + 1
-
-                   ENDIF
+
+             move_also_north(nr_move_north) = agent_array(n)
+             IF ( jp == ny+1 )  THEN
+!
+!--             Apply boundary condition along y
+                IF ( ibc_mas_ns == 0 )  THEN
+
+                   move_also_north(nr_move_north)%y = move_also_north(nr_move_north)%y             &
+                                                      - ( ny + 1 ) * dy
+                   move_also_north(nr_move_north)%origin_y =                                       &
+                                                        move_also_north(nr_move_north)%origin_y    &
+                                                        - ( ny + 1 ) * dy
+                ELSEIF ( ibc_mas_ns == 1 )  THEN
+!
+!--                Agent absorption
+                   move_also_north(nr_move_north)%agent_mask = .FALSE.
+                   deleted_agents = deleted_agents + 1
+
                 ENDIF
              ENDIF
           ENDIF
-       ENDDO
-
-       RETURN
-
-    END SUBROUTINE mas_eh_add_agents_to_gridcell
+       ENDIF
+    ENDDO
+
+    RETURN
+
+ END SUBROUTINE mas_eh_add_agents_to_gridcell
 #endif
 
 
 #if defined( __parallel )
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> After ghost layer agents have been received from neighboring PEs, this
-!> subroutine sorts them into the corresponding grid cells
-!------------------------------------------------------------------------------!
-    SUBROUTINE mas_eh_add_ghost_agents_to_gridcell (agent_array)
-
-       IMPLICIT NONE
-
-       INTEGER(iwp) ::  ip     !< grid index (x) of agent
-       INTEGER(iwp) ::  jp     !< grid index (x) of agent
-       INTEGER(iwp) ::  n      !< index variable of agent
-       INTEGER(iwp) ::  aindex !< dummy argument for new number of agents per grid box
-
-       LOGICAL ::  pack_done !< flag to indicate that packing is done
-
-       TYPE(agent_type), DIMENSION(:), INTENT(IN)  ::  agent_array !< new agents in a grid box
-
-       pack_done     = .FALSE.
-
-       DO n = 1, SIZE(agent_array)
-
-          IF ( .NOT. agent_array(n)%agent_mask )  CYCLE
-
-          ip = agent_array(n)%x * ddx
-          jp = agent_array(n)%y * ddy
-
-          IF ( ip < nxl  .OR.  ip > nxr  .OR.  jp < nys  .OR.  jp > nyn ) THEN
-             number_of_agents = agt_count(jp,ip)
-             agents => grid_agents(jp,ip)%agents(1:number_of_agents)
-
-             aindex = agt_count(jp,ip)+1
-             IF( aindex > SIZE(grid_agents(jp,ip)%agents) )  THEN
-                IF ( pack_done )  THEN
+!> After ghost layer agents have been received from neighboring PEs, this subroutine sorts them into
+!> the corresponding grid cells
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE mas_eh_add_ghost_agents_to_gridcell (agent_array)
+
+    IMPLICIT NONE
+
+    INTEGER(iwp) ::  aindex  !< dummy argument for new number of agents per grid box
+    INTEGER(iwp) ::  ip      !< grid index (x) of agent
+    INTEGER(iwp) ::  jp      !< grid index (x) of agent
+    INTEGER(iwp) ::  n       !< index variable of agent
+
+    LOGICAL ::  pack_done  !< flag to indicate that packing is done
+
+    TYPE(agent_type), DIMENSION(:), INTENT(IN)  ::  agent_array  !< new agents in a grid box
+
+    pack_done     = .FALSE.
+
+    DO  n = 1, SIZE(agent_array)
+
+       IF ( .NOT. agent_array(n)%agent_mask )  CYCLE
+
+       ip = agent_array(n)%x * ddx
+       jp = agent_array(n)%y * ddy
+
+       IF ( ip < nxl  .OR.  ip > nxr  .OR.  jp < nys  .OR.  jp > nyn )  THEN
+          number_of_agents = agt_count(jp,ip)
+          agents => grid_agents(jp,ip)%agents(1:number_of_agents)
+
+          aindex = agt_count(jp,ip)+1
+          IF( aindex > SIZE( grid_agents(jp,ip)%agents ) )  THEN
+             IF ( pack_done )  THEN
+                CALL mas_eh_realloc_agents_array (ip,jp)
+             ELSE
+                CALL mas_ps_pack
+                agt_count(jp,ip) = number_of_agents
+                aindex = agt_count(jp,ip)+1
+                IF ( aindex > SIZE( grid_agents(jp,ip)%agents ) )  THEN
                    CALL mas_eh_realloc_agents_array (ip,jp)
-                ELSE
-                   CALL mas_ps_pack
-                   agt_count(jp,ip) = number_of_agents
-                   aindex = agt_count(jp,ip)+1
-                   IF ( aindex > SIZE(grid_agents(jp,ip)%agents) )  THEN
-                      CALL mas_eh_realloc_agents_array (ip,jp)
-                   ENDIF
-                   pack_done = .TRUE.
                 ENDIF
+                pack_done = .TRUE.
              ENDIF
-             grid_agents(jp,ip)%agents(aindex) = agent_array(n)
-             agt_count(jp,ip) = aindex
           ENDIF
-       ENDDO
-    END SUBROUTINE mas_eh_add_ghost_agents_to_gridcell
+          grid_agents(jp,ip)%agents(aindex) = agent_array(n)
+          agt_count(jp,ip) = aindex
+       ENDIF
+    ENDDO
+ END SUBROUTINE mas_eh_add_ghost_agents_to_gridcell
 #endif
 
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Resizing of agent arrays
-!------------------------------------------------------------------------------!
-    SUBROUTINE mas_eh_dealloc_agents_array
-
-       IMPLICIT NONE
-
-       INTEGER(iwp) ::  i         !< grid index (x) of agent
-       INTEGER(iwp) ::  j         !< grid index (y) of agent
-       INTEGER(iwp) ::  old_size  !< old array size
-       INTEGER(iwp) ::  new_size  !< new array size
-       INTEGER(iwp) ::  noa       !< number of agents
-
-       LOGICAL ::  dealloc  !< flag that indicates if reallocation is necessary
-
-       TYPE(agent_type), DIMENSION(10) ::  tmp_agents_s !< temporary static agent array
-
-       TYPE(agent_type), DIMENSION(:), ALLOCATABLE ::  tmp_agents_d !< temporary dynamic agent array
-
-       DO  i = nxlg, nxrg
-          DO  j = nysg, nyng
-!
-!--          Determine number of active agents
-             noa = agt_count(j,i)
-!
-!--          Determine allocated memory size
-             old_size = SIZE( grid_agents(j,i)%agents )
-!
-!--          Check for large unused memory
-             dealloc = ( ( noa < min_nr_agent .AND. old_size  > min_nr_agent ) &
-                    .OR. ( noa > min_nr_agent .AND. old_size - noa *           &
-                         ( 1.0_wp + 0.01_wp * alloc_factor_mas ) > 0.0_wp ) )
-!
-!--          If large unused memory was found, resize the corresponding array
-             IF ( dealloc )  THEN
-                IF ( noa < min_nr_agent )  THEN
-                   new_size = min_nr_agent
-                ELSE 
-                   new_size = INT( noa * ( 1.0_wp +                            &
-                                            0.01_wp * alloc_factor_mas ) )
-                ENDIF
-
-                IF ( noa <= 10 )  THEN
-
-                   tmp_agents_s(1:noa) = grid_agents(j,i)%agents(1:noa)
-
-                   DEALLOCATE(grid_agents(j,i)%agents)
-                   ALLOCATE(grid_agents(j,i)%agents(1:new_size))
-
-                   grid_agents(j,i)%agents(1:noa)          = tmp_agents_s(1:noa)
-                   grid_agents(j,i)%agents(noa+1:new_size) = zero_agent
-
-                ELSE
-
-                   ALLOCATE(tmp_agents_d(noa))
-                   tmp_agents_d(1:noa) = grid_agents(j,i)%agents(1:noa)
-
-                   DEALLOCATE(grid_agents(j,i)%agents)
-                   ALLOCATE(grid_agents(j,i)%agents(new_size))
-
-                   grid_agents(j,i)%agents(1:noa)          = tmp_agents_d(1:noa)
-                   grid_agents(j,i)%agents(noa+1:new_size) = zero_agent
-
-                   DEALLOCATE(tmp_agents_d)
-
-                ENDIF
-
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE mas_eh_dealloc_agents_array
+
+    IMPLICIT NONE
+
+    INTEGER(iwp) ::  i         !< grid index (x) of agent
+    INTEGER(iwp) ::  j         !< grid index (y) of agent
+    INTEGER(iwp) ::  new_size  !< new array size
+    INTEGER(iwp) ::  noa       !< number of agents
+    INTEGER(iwp) ::  old_size  !< old array size
+
+    LOGICAL ::  dealloc  !< flag that indicates if reallocation is necessary
+
+    TYPE(agent_type), DIMENSION(10) ::  tmp_agents_s  !< temporary static agent array
+
+    TYPE(agent_type), DIMENSION(:), ALLOCATABLE ::  tmp_agents_d  !< temporary dynamic agent array
+
+    DO  i = nxlg, nxrg
+       DO  j = nysg, nyng
+!
+!--       Determine number of active agents
+          noa = agt_count(j,i)
+!
+!--       Determine allocated memory size
+          old_size = SIZE( grid_agents(j,i)%agents )
+!
+!--       Check for large unused memory
+          dealloc = ( ( noa < min_nr_agent .AND. old_size  > min_nr_agent )  .OR.                  &
+                      ( noa > min_nr_agent .AND.                                                   &
+                        old_size - noa * ( 1.0_wp + 0.01_wp * alloc_factor_mas ) > 0.0_wp )        &
+                    )
+!
+!--       If large unused memory was found, resize the corresponding array
+          IF ( dealloc )  THEN
+             IF ( noa < min_nr_agent )  THEN
+                new_size = min_nr_agent
+             ELSE
+                new_size = INT( noa * ( 1.0_wp + 0.01_wp * alloc_factor_mas ) )
              ENDIF
-          ENDDO
+
+             IF ( noa <= 10 )  THEN
+
+                tmp_agents_s(1:noa) = grid_agents(j,i)%agents(1:noa)
+
+                DEALLOCATE(grid_agents(j,i)%agents)
+                ALLOCATE(grid_agents(j,i)%agents(1:new_size))
+
+                grid_agents(j,i)%agents(1:noa)          = tmp_agents_s(1:noa)
+                grid_agents(j,i)%agents(noa+1:new_size) = zero_agent
+
+             ELSE
+
+                ALLOCATE(tmp_agents_d(noa))
+                tmp_agents_d(1:noa) = grid_agents(j,i)%agents(1:noa)
+
+                DEALLOCATE(grid_agents(j,i)%agents)
+                ALLOCATE(grid_agents(j,i)%agents(new_size))
+
+                grid_agents(j,i)%agents(1:noa)          = tmp_agents_d(1:noa)
+                grid_agents(j,i)%agents(noa+1:new_size) = zero_agent
+
+                DEALLOCATE(tmp_agents_d)
+
+             ENDIF
+
+          ENDIF
        ENDDO
-
-    END SUBROUTINE mas_eh_dealloc_agents_array
-
-!------------------------------------------------------------------------------!
+    ENDDO
+
+ END SUBROUTINE mas_eh_dealloc_agents_array
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Exchange between subdomains.
-!> As soon as one agent has moved beyond the boundary of the domain, it
-!> is included in the relevant transfer arrays and marked for subsequent
-!> deletion on this PE.
-!> First sweep for crossings in x direction. Find out first the number of
-!> agents to be transferred and allocate temporary arrays needed to store
-!> them.
-!> For a one-dimensional decomposition along y, no transfer is necessary,
-!> because the agent remains on the PE, but the agent coordinate has to
-!> be adjusted.
-!------------------------------------------------------------------------------!
-    SUBROUTINE mas_eh_exchange_horiz
-
-       IMPLICIT NONE
-
-       INTEGER(iwp) ::  ip               !< index variable along x
-       INTEGER(iwp) ::  jp               !< index variable along y
-       INTEGER(iwp) ::  n                !< agent index variable
+!> As soon as one agent has moved beyond the boundary of the domain, it is included in the relevant
+!> transfer arrays and marked for subsequent deletion on this PE.
+!> First sweep for crossings in x direction. Find out first the number of agents to be transferred
+!> and allocate temporary arrays needed to store them.
+!> For a one-dimensional decomposition along y, no transfer is necessary, because the agent remains
+!> on the PE, but the agent coordinate has to be adjusted.
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE mas_eh_exchange_horiz
+
+    IMPLICIT NONE
+
+    INTEGER(iwp) ::  ip               !< index variable along x
+    INTEGER(iwp) ::  jp               !< index variable along y
+    INTEGER(iwp) ::  n                !< agent index variable
 
 #if defined( __parallel )
 
-       INTEGER(iwp) ::  i                !< grid index (x) of agent positition
-       INTEGER(iwp) ::  j                !< grid index (y) of agent positition
-       INTEGER(iwp) ::  par_size         !< Agent size in bytes
-
-       INTEGER(iwp) ::  trla_count       !< number of agents send to left PE
-       INTEGER(iwp) ::  trla_count_recv  !< number of agents receive from right PE
-       INTEGER(iwp) ::  trna_count       !< number of agents send to north PE
-       INTEGER(iwp) ::  trna_count_recv  !< number of agents receive from south PE
-       INTEGER(iwp) ::  trra_count       !< number of agents send to right PE
-       INTEGER(iwp) ::  trra_count_recv  !< number of agents receive from left PE
-       INTEGER(iwp) ::  trsa_count       !< number of agents send to south PE
-       INTEGER(iwp) ::  trsa_count_recv  !< number of agents receive from north PE
-
-       TYPE(agent_type), DIMENSION(:), ALLOCATABLE ::  rvla  !< agents received from right PE
-       TYPE(agent_type), DIMENSION(:), ALLOCATABLE ::  rvna  !< agents received from south PE
-       TYPE(agent_type), DIMENSION(:), ALLOCATABLE ::  rvra  !< agents received from left PE
-       TYPE(agent_type), DIMENSION(:), ALLOCATABLE ::  rvsa  !< agents received from north PE
-       TYPE(agent_type), DIMENSION(:), ALLOCATABLE ::  trla  !< agents send to left PE
-       TYPE(agent_type), DIMENSION(:), ALLOCATABLE ::  trna  !< agents send to north PE
-       TYPE(agent_type), DIMENSION(:), ALLOCATABLE ::  trra  !< agents send to right PE
-       TYPE(agent_type), DIMENSION(:), ALLOCATABLE ::  trsa  !< agents send to south PE
-
-!
-!--    Exchange between subdomains.
-!--    As soon as one agent has moved beyond the boundary of the domain, it
-!--    is included in the relevant transfer arrays and marked for subsequent
-!--    deletion on this PE.
-!--    First sweep for crossings in x direction. Find out first the number of
-!--    agents to be transferred and allocate temporary arrays needed to store
-!--    them.
-!--    For a one-dimensional decomposition along y, no transfer is necessary,
-!--    because the agent remains on the PE, but the agent coordinate has to
-!--    be adjusted.
-       trla_count  = 0
-       trra_count  = 0
-
-       trla_count_recv   = 0
-       trra_count_recv   = 0
-
-       IF ( pdims(1) /= 1 )  THEN
-!
-!--       First calculate the storage necessary for sending and receiving the data.
-!--       Compute only first (nxl) and last (nxr) loop iterration.
-          DO  ip = nxl, nxr, nxr - nxl
-             DO  jp = nys, nyn
-
-                number_of_agents = agt_count(jp,ip)
-                IF ( number_of_agents <= 0 )  CYCLE
-                agents => grid_agents(jp,ip)%agents(1:number_of_agents)
-                DO  n = 1, number_of_agents
-                   IF ( agents(n)%agent_mask )  THEN
-                      i = agents(n)%x * ddx
-!
-!--                   Above calculation does not work for indices less than zero
-                      IF ( agents(n)%x < 0.0_wp )  i = -1
-
-                      IF ( i < nxl )  THEN
-                         trla_count = trla_count + 1
-                      ELSEIF ( i > nxr )  THEN
-                         trra_count = trra_count + 1
-                      ENDIF
-                   ENDIF
-                ENDDO
-
-             ENDDO
-          ENDDO
-
-          IF ( trla_count  == 0 )  trla_count  = 1
-          IF ( trra_count  == 0 )  trra_count  = 1
-
-          ALLOCATE( trla(trla_count), trra(trra_count) )
-
-          trla = zero_agent
-          trra = zero_agent
-
-          trla_count  = 0
-          trra_count  = 0
-
-       ENDIF
-!
-!--    Compute only first (nxl) and last (nxr) loop iterration
-       DO  ip = nxl, nxr, nxr-nxl
+    INTEGER(iwp) ::  i                !< grid index (x) of agent positition
+    INTEGER(iwp) ::  j                !< grid index (y) of agent positition
+    INTEGER(iwp) ::  par_size         !< Agent size in bytes
+
+    INTEGER(iwp) ::  trla_count       !< number of agents send to left PE
+    INTEGER(iwp) ::  trla_count_recv  !< number of agents receive from right PE
+    INTEGER(iwp) ::  trna_count       !< number of agents send to north PE
+    INTEGER(iwp) ::  trna_count_recv  !< number of agents receive from south PE
+    INTEGER(iwp) ::  trra_count       !< number of agents send to right PE
+    INTEGER(iwp) ::  trra_count_recv  !< number of agents receive from left PE
+    INTEGER(iwp) ::  trsa_count       !< number of agents send to south PE
+    INTEGER(iwp) ::  trsa_count_recv  !< number of agents receive from north PE
+
+    TYPE(agent_type), DIMENSION(:), ALLOCATABLE ::  rvla  !< agents received from right PE
+    TYPE(agent_type), DIMENSION(:), ALLOCATABLE ::  rvna  !< agents received from south PE
+    TYPE(agent_type), DIMENSION(:), ALLOCATABLE ::  rvra  !< agents received from left PE
+    TYPE(agent_type), DIMENSION(:), ALLOCATABLE ::  rvsa  !< agents received from north PE
+    TYPE(agent_type), DIMENSION(:), ALLOCATABLE ::  trla  !< agents send to left PE
+    TYPE(agent_type), DIMENSION(:), ALLOCATABLE ::  trna  !< agents send to north PE
+    TYPE(agent_type), DIMENSION(:), ALLOCATABLE ::  trra  !< agents send to right PE
+    TYPE(agent_type), DIMENSION(:), ALLOCATABLE ::  trsa  !< agents send to south PE
+
+!
+!-- Exchange between subdomains.
+!-- As soon as one agent has moved beyond the boundary of the domain, it is included in the relevant
+!-- transfer arrays and marked for subsequent deletion on this PE.
+!-- First sweep for crossings in x direction. Find out first the number of agents to be transferred
+!-- and allocate temporary arrays needed to store them.
+!-- For a one-dimensional decomposition along y, no transfer is necessary, because the agent remains
+!-- on the PE, but the agent coordinate has to be adjusted.
+    trla_count  = 0
+    trra_count  = 0
+
+    trla_count_recv   = 0
+    trra_count_recv   = 0
+
+    IF ( pdims(1) /= 1 )  THEN
+!
+!--    First calculate the storage necessary for sending and receiving the data.
+!--    Compute only first (nxl) and last (nxr) loop iterration.
+       DO  ip = nxl, nxr, nxr - nxl
           DO  jp = nys, nyn
-             number_of_agents = agt_count(jp,ip)
-             IF ( number_of_agents <= 0 ) CYCLE
-             agents => grid_agents(jp,ip)%agents(1:number_of_agents)
-             DO  n = 1, number_of_agents
-!
-!--             Only those agents that have not been marked as 'deleted' may
-!--             be moved.
-                IF ( agents(n)%agent_mask )  THEN
-
-                   i = agents(n)%x * ddx
-!
-!--                Above calculation does not work for indices less than zero
-                   IF ( agents(n)%x < 0.0_wp )  i = -1
-
-                   IF ( i <  nxl )  THEN
-                      IF ( i < 0 )  THEN
-!
-!--                      Apply boundary condition along x
-                         IF ( ibc_mas_lr == 0 )  THEN
-!
-!--                         Cyclic condition
-                            IF ( pdims(1) == 1 )  THEN
-                               agents(n)%x        = ( nx + 1 ) * dx +          &
-                                                    agents(n)%x
-                               agents(n)%origin_x = ( nx + 1 ) * dx +          &
-                                                    agents(n)%origin_x
-                            ELSE
-                               trla_count         = trla_count + 1
-                               trla(trla_count)   = agents(n)
-                               trla(trla_count)%x = ( nx + 1 ) * dx +          &
-                                                    trla(trla_count)%x
-                               trla(trla_count)%origin_x =                     &
-                                                trla(trla_count)%origin_x +    &
-                                                ( nx + 1 ) * dx
-                               agents(n)%agent_mask  = .FALSE.
-                               deleted_agents = deleted_agents + 1
-
-                               IF ( trla(trla_count)%x >=                      &
-                                        (nx + 1)* dx - 1.0E-12_wp )            &
-                               THEN
-                                  trla(trla_count)%x = trla(trla_count)%x -    &
-                                                   1.0E-10_wp
-                                  trla(trla_count)%origin_x =                  &
-                                                   trla(trla_count)%origin_x - 1
-                               ENDIF
-
-                            ENDIF
-
-                         ELSEIF ( ibc_mas_lr == 1 )  THEN
-!
-!--                         Agent absorption
-                            agents(n)%agent_mask = .FALSE.
-                            deleted_agents = deleted_agents + 1
-
-                         ENDIF
-                      ELSE
-!
-!--                      Store agent data in the transfer array, which will be 
-!--                      send to the neighbouring PE
-                         trla_count = trla_count + 1
-                         trla(trla_count) = agents(n)
-                         agents(n)%agent_mask = .FALSE.
-                         deleted_agents = deleted_agents + 1
-
-                      ENDIF
-
-                   ELSEIF ( i > nxr )  THEN
-                      IF ( i > nx )  THEN
-!
-!--                      Apply boundary condition along x
-                         IF ( ibc_mas_lr == 0 )  THEN
-!
-!--                         Cyclic condition
-                            IF ( pdims(1) == 1 )  THEN
-                               agents(n)%x = agents(n)%x - ( nx + 1 ) * dx
-                               agents(n)%origin_x = agents(n)%origin_x - &
-                               ( nx + 1 ) * dx
-                            ELSE
-                               trra_count = trra_count + 1
-                               trra(trra_count) = agents(n)
-                               trra(trra_count)%x = trra(trra_count)%x -       &
-                                                    ( nx + 1 ) * dx
-                               trra(trra_count)%origin_x =                     &
-                                                   trra(trra_count)%origin_x - &
-                                                   ( nx + 1 ) * dx
-                               agents(n)%agent_mask = .FALSE.
-                               deleted_agents = deleted_agents + 1
-
-                            ENDIF
-
-                         ELSEIF ( ibc_mas_lr == 1 )  THEN
-!
-!--                         Agent absorption
-                            agents(n)%agent_mask = .FALSE.
-                            deleted_agents = deleted_agents + 1
-
-                         ENDIF
-                      ELSE
-!
-!--                      Store agent data in the transfer array, which will be send
-!--                      to the neighbouring PE
-                         trra_count = trra_count + 1
-                         trra(trra_count) = agents(n)
-                         agents(n)%agent_mask = .FALSE.
-                         deleted_agents = deleted_agents + 1
-
-                      ENDIF
-
-                   ENDIF
-                ENDIF
-
-             ENDDO
-          ENDDO
-       ENDDO
-
-!
-!--    Allocate arrays required for north-south exchange, as these
-!--    are used directly after agents are exchange along x-direction.
-       ALLOCATE( move_also_north(1:NR_2_direction_move) )
-       ALLOCATE( move_also_south(1:NR_2_direction_move) )
-
-       nr_move_north = 0
-       nr_move_south = 0
-!
-!--    Send left boundary, receive right boundary (but first exchange how many
-!--    and chec if agent storage must be extended)
-       IF ( pdims(1) /= 1 )  THEN
-
-          CALL MPI_SENDRECV( trla_count,      1, MPI_INTEGER, pleft,  0, &
-                             trra_count_recv, 1, MPI_INTEGER, pright, 0, &
-                             comm2d, status, ierr )
-
-          ALLOCATE(rvra(MAX(1,trra_count_recv)))
-!
-!--       This MPI_SENDRECV should work even with odd mixture on 32 and 64 Bit 
-!--       variables in structure agent_type (due to the calculation of par_size)
-          par_size = STORAGE_SIZE(trla(1))/8
-          CALL MPI_SENDRECV( trla, max(1,trla_count)*par_size, MPI_BYTE, pleft,&
-                    1, rvra, max(1,trra_count_recv)*par_size, MPI_BYTE, pright,&
-                             1, comm2d, status, ierr )
-
-          IF ( trra_count_recv > 0 ) THEN
-             CALL mas_eh_add_agents_to_gridcell(rvra(1:trra_count_recv))
-          ENDIF
-
-          DEALLOCATE(rvra)
-
-!
-!--       Send right boundary, receive left boundary
-          CALL MPI_SENDRECV( trra_count,      1, MPI_INTEGER, pright, 0,       &
-                             trla_count_recv, 1, MPI_INTEGER, pleft,  0,       &
-                             comm2d, status, ierr )
-
-          ALLOCATE(rvla(MAX(1,trla_count_recv)))
-!
-!--       This MPI_SENDRECV should work even with odd mixture on 32 and 64 Bit 
-!--       variables in structure agent_type (due to the calculation of par_size)
-          par_size = STORAGE_SIZE(trra(1))/8
-          CALL MPI_SENDRECV( trra, max(1,trra_count)*par_size, MPI_BYTE,       &
-                             pright, 1, rvla,                                  &
-                             max(1,trla_count_recv)*par_size, MPI_BYTE,        &
-                             pleft, 1, comm2d, status, ierr )
-
-          IF ( trla_count_recv > 0 ) THEN
-             CALL mas_eh_add_agents_to_gridcell(rvla(1:trla_count_recv))
-          ENDIF
-
-          DEALLOCATE( rvla )
-          DEALLOCATE( trla, trra )
-
-       ENDIF
-
-!
-!--    Check whether agents have crossed the boundaries in y direction. Note 
-!--    that this case can also apply to agents that have just been received
-!--    from the adjacent right or left PE.
-!--    Find out first the number of agents to be transferred and allocate
-!--    temporary arrays needed to store them.
-!--    For a one-dimensional decomposition along y, no transfer is necessary,
-!--    because the agent remains on the PE.
-       trsa_count  = nr_move_south
-       trna_count  = nr_move_north
-
-       trsa_count_recv   = 0
-       trna_count_recv   = 0
-
-       IF ( pdims(2) /= 1 )  THEN
-!
-!--       First calculate the storage necessary for sending and receiving the
-!--       data
-          DO  ip = nxl, nxr
-             DO  jp = nys, nyn, nyn-nys    !compute only first (nys) and last (nyn) loop iterration
-                number_of_agents = agt_count(jp,ip)
-                IF ( number_of_agents <= 0 )  CYCLE
-                agents => grid_agents(jp,ip)%agents(1:number_of_agents)
-                DO  n = 1, number_of_agents
-                   IF ( agents(n)%agent_mask )  THEN
-                      j = agents(n)%y * ddy
-!
-!--                   Above calculation does not work for indices less than zero
-                      IF ( agents(n)%y < 0.0_wp )  j = -1
-
-                      IF ( j < nys )  THEN
-                         trsa_count = trsa_count + 1
-                      ELSEIF ( j > nyn )  THEN
-                         trna_count = trna_count + 1
-                      ENDIF
-                   ENDIF
-                ENDDO
-             ENDDO
-          ENDDO
-
-          IF ( trsa_count  == 0 )  trsa_count  = 1
-          IF ( trna_count  == 0 )  trna_count  = 1
-
-          ALLOCATE( trsa(trsa_count), trna(trna_count) )
-
-          trsa = zero_agent
-          trna = zero_agent
-
-          trsa_count  = nr_move_south
-          trna_count  = nr_move_north
-
-          trsa(1:nr_move_south) = move_also_south(1:nr_move_south)
-          trna(1:nr_move_north) = move_also_north(1:nr_move_north)
-
-       ENDIF
-
-       DO  ip = nxl, nxr
-          DO  jp = nys, nyn, nyn-nys ! compute only first (nys) and last (nyn) loop iterration
+
              number_of_agents = agt_count(jp,ip)
              IF ( number_of_agents <= 0 )  CYCLE
              agents => grid_agents(jp,ip)%agents(1:number_of_agents)
              DO  n = 1, number_of_agents
-!
-!--             Only those agents that have not been marked as 'deleted' may
-!--             be moved.
                 IF ( agents(n)%agent_mask )  THEN
-
-                   j = agents(n)%y * ddy
+                   i = agents(n)%x * ddx
 !
 !--                Above calculation does not work for indices less than zero
-                   IF ( agents(n)%y < 0.0_wp * dy )  j = -1
-
-                   IF ( j < nys )  THEN
-                      IF ( j < 0 )  THEN
-!
-!--                      Apply boundary condition along y
-                         IF ( ibc_mas_ns == 0 )  THEN
-!
-!--                         Cyclic condition
-                            IF ( pdims(2) == 1 )  THEN
-                               agents(n)%y = ( ny + 1 ) * dy + agents(n)%y
-                               agents(n)%origin_y = ( ny + 1 ) * dy +          &
-                                                     agents(n)%origin_y
-                            ELSE
-                               trsa_count         = trsa_count + 1
-                               trsa(trsa_count)   = agents(n)
-                               trsa(trsa_count)%y = ( ny + 1 ) * dy +          &
-                                                 trsa(trsa_count)%y
-                               trsa(trsa_count)%origin_y =                     &
-                                                  trsa(trsa_count)%origin_y    &
-                                                + ( ny + 1 ) * dy
-                               agents(n)%agent_mask = .FALSE.
-                               deleted_agents = deleted_agents + 1
-
-                               IF ( trsa(trsa_count)%y >=                      &
-                                                    (ny+1)* dy - 1.0E-12_wp )  &
-                               THEN
-                                  trsa(trsa_count)%y = trsa(trsa_count)%y -    &
-                                                       1.0E-10_wp
-                                  trsa(trsa_count)%origin_y =                  &
-                                                  trsa(trsa_count)%origin_y - 1
-                               ENDIF
-
+                   IF ( agents(n)%x < 0.0_wp )  i = -1
+
+                   IF ( i < nxl )  THEN
+                      trla_count = trla_count + 1
+                   ELSEIF ( i > nxr )  THEN
+                      trra_count = trra_count + 1
+                   ENDIF
+                ENDIF
+             ENDDO
+
+          ENDDO
+       ENDDO
+
+       IF ( trla_count  == 0 )  trla_count  = 1
+       IF ( trra_count  == 0 )  trra_count  = 1
+
+       ALLOCATE( trla(trla_count), trra(trra_count) )
+
+       trla = zero_agent
+       trra = zero_agent
+
+       trla_count  = 0
+       trra_count  = 0
+
+    ENDIF
+!
+!-- Compute only first (nxl) and last (nxr) loop iterration
+    DO  ip = nxl, nxr, nxr-nxl
+       DO  jp = nys, nyn
+          number_of_agents = agt_count(jp,ip)
+          IF ( number_of_agents <= 0 ) CYCLE
+          agents => grid_agents(jp,ip)%agents(1:number_of_agents)
+          DO  n = 1, number_of_agents
+!
+!--          Only those agents that have not been marked as 'deleted' may be moved.
+             IF ( agents(n)%agent_mask )  THEN
+
+                i = agents(n)%x * ddx
+!
+!--             Above calculation does not work for indices less than zero
+                IF ( agents(n)%x < 0.0_wp )  i = -1
+
+                IF ( i <  nxl )  THEN
+                   IF ( i < 0 )  THEN
+!
+!--                   Apply boundary condition along x
+                      IF ( ibc_mas_lr == 0 )  THEN
+!
+!--                      Cyclic condition
+                         IF ( pdims(1) == 1 )  THEN
+                            agents(n)%x        = ( nx + 1 ) * dx + agents(n)%x
+                            agents(n)%origin_x = ( nx + 1 ) * dx + agents(n)%origin_x
+                         ELSE
+                            trla_count         = trla_count + 1
+                            trla(trla_count)   = agents(n)
+                            trla(trla_count)%x = ( nx + 1 ) * dx + trla(trla_count)%x
+                            trla(trla_count)%origin_x = trla(trla_count)%origin_x + ( nx + 1 ) * dx
+                            agents(n)%agent_mask  = .FALSE.
+                            deleted_agents = deleted_agents + 1
+
+                            IF ( trla(trla_count)%x >= (nx + 1)* dx - 1.0E-12_wp )  THEN
+                               trla(trla_count)%x = trla(trla_count)%x - 1.0E-10_wp
+                               trla(trla_count)%origin_x = trla(trla_count)%origin_x - 1
                             ENDIF
 
-                         ELSEIF ( ibc_mas_ns == 1 )  THEN
-!
-!--                         Agent absorption
-                            agents(n)%agent_mask = .FALSE.
-                            deleted_agents          = deleted_agents + 1
-
                          ENDIF
-                      ELSE
-!
-!--                      Store agent data in the transfer array, which will 
-!--                      be send to the neighbouring PE
-                         trsa_count = trsa_count + 1
-                         trsa(trsa_count) = agents(n)
+
+                      ELSEIF ( ibc_mas_lr == 1 )  THEN
+!
+!--                      Agent absorption
                          agents(n)%agent_mask = .FALSE.
                          deleted_agents = deleted_agents + 1
 
                       ENDIF
-
-                   ELSEIF ( j > nyn )  THEN
-                      IF ( j > ny )  THEN
-!
-!--                      Apply boundary condition along y
-                         IF ( ibc_mas_ns == 0 )  THEN
-!
-!--                         Cyclic condition
-                            IF ( pdims(2) == 1 )  THEN
-                               agents(n)%y        = agents(n)%y -              &
-                                                    ( ny + 1 ) * dy
-                               agents(n)%origin_y = agents(n)%origin_y -       &
-                                                    ( ny + 1 ) * dy
-                            ELSE
-                               trna_count         = trna_count + 1
-                               trna(trna_count)   = agents(n)
-                               trna(trna_count)%y =                            &
-                                          trna(trna_count)%y - ( ny + 1 ) * dy
-                               trna(trna_count)%origin_y =                     &
-                                         trna(trna_count)%origin_y -           &
-                                         ( ny + 1 ) * dy
-                               agents(n)%agent_mask = .FALSE.
-                               deleted_agents          = deleted_agents + 1
-                            ENDIF
-
-                         ELSEIF ( ibc_mas_ns == 1 )  THEN
-!
-!--                         Agent absorption
+                   ELSE
+!
+!--                   Store agent data in the transfer array, which will be send to the neighbouring
+!--                   PE.
+                      trla_count = trla_count + 1
+                      trla(trla_count) = agents(n)
+                      agents(n)%agent_mask = .FALSE.
+                      deleted_agents = deleted_agents + 1
+
+                   ENDIF
+
+                ELSEIF ( i > nxr )  THEN
+                   IF ( i > nx )  THEN
+!
+!--                   Apply boundary condition along x
+                      IF ( ibc_mas_lr == 0 )  THEN
+!
+!--                      Cyclic condition
+                         IF ( pdims(1) == 1 )  THEN
+                            agents(n)%x = agents(n)%x - ( nx + 1 ) * dx
+                            agents(n)%origin_x = agents(n)%origin_x - ( nx + 1 ) * dx
+                         ELSE
+                            trra_count = trra_count + 1
+                            trra(trra_count) = agents(n)
+                            trra(trra_count)%x = trra(trra_count)%x - ( nx + 1 ) * dx
+                            trra(trra_count)%origin_x = trra(trra_count)%origin_x - ( nx + 1 ) * dx
                             agents(n)%agent_mask = .FALSE.
                             deleted_agents = deleted_agents + 1
 
                          ENDIF
-                      ELSE
-!
-!--                      Store agent data in the transfer array, which will 
-!--                      be send to the neighbouring PE
-                         trna_count = trna_count + 1
-                         trna(trna_count) = agents(n)
+
+                      ELSEIF ( ibc_mas_lr == 1 )  THEN
+!
+!--                      Agent absorption
                          agents(n)%agent_mask = .FALSE.
                          deleted_agents = deleted_agents + 1
 
                       ENDIF
-
+                   ELSE
+!
+!--                   Store agent data in the transfer array, which will be send to the neighbouring
+!--                   PE.
+                      trra_count = trra_count + 1
+                      trra(trra_count) = agents(n)
+                      agents(n)%agent_mask = .FALSE.
+                      deleted_agents = deleted_agents + 1
+
+                   ENDIF
+
+                ENDIF
+             ENDIF
+
+          ENDDO
+       ENDDO
+    ENDDO
+
+!
+!-- Allocate arrays required for north-south exchange, as these are used directly after agents are
+!-- exchange along x-direction.
+    ALLOCATE( move_also_north(1:nr_2_direction_move) )
+    ALLOCATE( move_also_south(1:nr_2_direction_move) )
+
+    nr_move_north = 0
+    nr_move_south = 0
+!
+!-- Send left boundary, receive right boundary (but first exchange how many and check if agent
+!-- storage must be extended).
+    IF ( pdims(1) /= 1 )  THEN
+
+       CALL MPI_SENDRECV( trla_count,      1, MPI_INTEGER, pleft,  0,                              &
+                          trra_count_recv, 1, MPI_INTEGER, pright, 0,                              &
+                          comm2d, status, ierr )
+
+       ALLOCATE( rvra(MAX( 1,trra_count_recv )) )
+!
+!--    This MPI_SENDRECV should work even with odd mixture on 32 and 64 Bit variables in structure
+!--    agent_type (due to the calculation of par_size)
+       par_size = STORAGE_SIZE( trla(1) ) / 8
+       CALL MPI_SENDRECV( trla, MAX( 1, trla_count ) * par_size,     MPI_BYTE, pleft,  1,          &
+                          rvra, MAX( 1, trra_count_recv )* par_size, MPI_BYTE, pright, 1,          &
+                          comm2d, status, ierr )
+
+       IF ( trra_count_recv > 0 )  THEN
+          CALL mas_eh_add_agents_to_gridcell(rvra(1:trra_count_recv))
+       ENDIF
+
+       DEALLOCATE(rvra)
+
+!
+!--    Send right boundary, receive left boundary
+       CALL MPI_SENDRECV( trra_count,      1, MPI_INTEGER, pright, 0,                              &
+                          trla_count_recv, 1, MPI_INTEGER, pleft,  0,                              &
+                          comm2d, status, ierr )
+
+       ALLOCATE(rvla(MAX(1,trla_count_recv)))
+!
+!--    This MPI_SENDRECV should work even with odd mixture on 32 and 64 Bit variables in structure
+!--    agent_type (due to the calculation of par_size)
+       par_size = STORAGE_SIZE(trra(1))/8
+       CALL MPI_SENDRECV( trra, MAX( 1, trra_count ) * par_size,   MPI_BYTE, pright, 1,            &
+                          rvla, MAX(1,trla_count_recv) * par_size, MPI_BYTE,  pleft, 1,            &
+                          comm2d, status, ierr )
+
+       IF ( trla_count_recv > 0 )  THEN
+          CALL mas_eh_add_agents_to_gridcell(rvla(1:trla_count_recv))
+       ENDIF
+
+       DEALLOCATE( rvla )
+       DEALLOCATE( trla, trra )
+
+    ENDIF
+
+!
+!-- Check whether agents have crossed the boundaries in y direction. Note that this case can also
+!-- apply to agents that have just been received from the adjacent right or left PE.
+!-- Find out first the number of agents to be transferred and allocate temporary arrays needed to
+!-- store them.
+!-- For a one-dimensional decomposition along y, no transfer is necessary, because the agent remains
+!-- on the PE.
+    trsa_count  = nr_move_south
+    trna_count  = nr_move_north
+
+    trsa_count_recv   = 0
+    trna_count_recv   = 0
+
+    IF ( pdims(2) /= 1 )  THEN
+!
+!--    First calculate the storage necessary for sending and receiving the data.
+       DO  ip = nxl, nxr
+          DO  jp = nys, nyn, nyn-nys    ! compute only first (nys) and last (nyn) loop iterration
+             number_of_agents = agt_count(jp,ip)
+             IF ( number_of_agents <= 0 )  CYCLE
+             agents => grid_agents(jp,ip)%agents(1:number_of_agents)
+             DO  n = 1, number_of_agents
+                IF ( agents(n)%agent_mask )  THEN
+                   j = agents(n)%y * ddy
+!
+!--                Above calculation does not work for indices less than zero
+                   IF ( agents(n)%y < 0.0_wp )  j = -1
+
+                   IF ( j < nys )  THEN
+                      trsa_count = trsa_count + 1
+                   ELSEIF ( j > nyn )  THEN
+                      trna_count = trna_count + 1
                    ENDIF
                 ENDIF
